Index: trunk/Cocoa/F-Script Anywhere/Source/FSAAppList.m
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/FSAAppList.m	(revision 19)
+++ trunk/Cocoa/F-Script Anywhere/Source/FSAAppList.m	(revision 153)
@@ -25,7 +25,6 @@
 */
 
+#import "FSAAppList.h"
 #import "FSAnywhere.h"
-#import "FSAAppList.h"
-#import "FSAApp.h"
 #import "libMatch.h"
 #import "DeVercruesseProcessManager.h"
@@ -43,4 +42,7 @@
 NSString *FSACheckMarkCharacter;
 NSImage *FSACheckMarkImage;
+
+NSString *FSAEllipsisCharacter;
+NSImage *FSAEllipsisImage;
 
 static const char *FSACocoaFrameworks[] = {
@@ -65,4 +67,10 @@
         FSALog(@"Falling back to checkmark image from bundle: %@", FSACheckMarkImage);
     }
+    FSAEllipsisCharacter = [[NSString alloc] initWithCharacters: (const unichar *)"\x20\x26" length: 1];
+    FSAEllipsisImage = [[NSImage alloc] initByReferencingFile: [[NSBundle mainBundle] pathForResource: @"Ellipsis" ofType: @"tiff"]];
+    if (FSAEllipsisImage != nil && ![FSAEllipsisImage isValid]) {
+        [FSAEllipsisImage release];
+        FSAEllipsisImage = nil;
+    }
 }
 
@@ -74,4 +82,5 @@
     cocoaApps = [[NSMutableArray alloc] init];
     patchedApps = [[NSMutableSet alloc] init];
+    patchingApps = [[NSMutableSet alloc] init];
     appsByPID = [[NSMutableDictionary alloc] init];
 
@@ -85,5 +94,4 @@
     [self update];
     [window makeFirstResponder: tableView];
-    [window makeKeyAndOrderFront: self];
 }
 
@@ -105,9 +113,27 @@
 }
 
+- (void)_processStatusChanged;
+{
+    [tableView reloadData];
+    [self tableView: tableView shouldSelectRow: [tableView selectedRow]];
+}
+
+- (DeVercruesseProcess *)_applicationForPID:(pid_t)pid;
+{
+    return [appsByPID objectForKey: [NSNumber numberWithInt: pid]];
+}
+
 - (void)didPatchProcessID:(pid_t)pid;
 {
-    [patchedApps addObject: [appsByPID objectForKey: [NSNumber numberWithInt: pid]]];
-    [tableView reloadData];
-    [installButton setEnabled: NO];
+    DeVercruesseProcess *app = [self _applicationForPID: pid];
+    [patchingApps removeObject: app];
+    [patchedApps addObject: app];
+    [self _processStatusChanged];
+}
+
+- (void)isPatchingProcessID:(pid_t)pid;
+{
+    [patchingApps addObject: [self _applicationForPID: pid]];
+    [self _processStatusChanged];
 }
 
@@ -201,5 +227,5 @@
     [cocoaApps removeAllObjects];
     [appsByPID removeAllObjects];
-    // [processManager update]; // [processManager processes] sends update
+    // [processManager update] unneeded: [processManager processes] sends update
 
     allApps = [processManager processes];
@@ -211,15 +237,21 @@
 
     [tableView noteNumberOfRowsChanged];
-    [tableView reloadData];
-    // XXX this is broken, it doesn't update properly
-    [self tableView: tableView shouldSelectRow: [tableView selectedRow]];
+    [self _processStatusChanged];
+}
+
+- (NSArray *)cocoaAppProcessIDs;
+{
+    NSEnumerator *e = [cocoaApps objectEnumerator];
+    NSMutableArray *pids = [NSMutableArray arrayWithCapacity: [cocoaApps count]];
+    DeVercruesseProcess *app;
+    while ( (app = [e nextObject]) != nil) {
+        [pids addObject: [NSNumber numberWithInt: [app pid]]];
+    }
+    return pids;
 }
 
 - (void)applicationLaunchedWithProcessID:(pid_t)pid;
 {
-    NSNumber *pidNum = [NSNumber numberWithInt: pid];
-    DeVercruesseProcess *app = [appsByPID objectForKey: pidNum];
-
-    if (app == nil) {
+    if ([self _applicationForPID: pid] == nil) {
         [self update];
     }
@@ -228,14 +260,14 @@
 - (void)applicationQuitWithProcessID:(pid_t)pid;
 {
-    NSNumber *pidNum = [NSNumber numberWithInt: pid];
-    DeVercruesseProcess *app = [appsByPID objectForKey: pidNum];
+    DeVercruesseProcess *app = [self _applicationForPID: pid];
 
     if (app != nil) {
         [cocoaApps removeObject: app];
-        [appsByPID removeObjectForKey: pidNum];
+        [appsByPID removeObjectForKey: [NSNumber numberWithLong: pid]];
         [patchedApps removeObject: app];
     }
 
-    [tableView reloadData];
+    [tableView noteNumberOfRowsChanged];
+    [self _processStatusChanged];
 }
 
@@ -260,5 +292,7 @@
 
     if (row != -1) {
-        canInstall = ![patchedApps containsObject: [cocoaApps objectAtIndex: row]];
+        DeVercruesseProcess *app = [cocoaApps objectAtIndex: row];
+        canInstall = !([patchedApps containsObject: app] ||
+                       [patchingApps containsObject: app]);
     }
 
@@ -286,9 +320,17 @@
         return [(DeVercruesseProcess *)[cocoaApps objectAtIndex: rowIndex] name];
     } else if ([columnIdentifier isEqualToString: FSATableColumnIdentifier_checkMark]) {
-        BOOL isPatched = [patchedApps containsObject: [cocoaApps objectAtIndex: rowIndex]];
-        if (FSACheckMarkImage == nil)
-            return isPatched ? FSACheckMarkCharacter : @"";
-        else
-            return isPatched ? FSACheckMarkImage : nil;
+        DeVercruesseProcess *app = [cocoaApps objectAtIndex: rowIndex];
+        if ([patchedApps containsObject: app]) {
+            if (FSACheckMarkImage == nil)
+                return FSACheckMarkCharacter;
+            else
+                return FSACheckMarkImage;
+        }
+        if ([patchingApps containsObject: app]) {
+            if (FSAEllipsisImage == nil)
+                return FSAEllipsisCharacter;
+            else
+                return FSAEllipsisImage;
+        }
     }
     return nil;
@@ -327,29 +369,4 @@
 }
 
-- (BOOL)windowShouldClose:(id)sender;
-{
-    if ([patchedApps count] != 0) {
-        NSMutableString *message =  [@"F-Script Anywhere is installed in the following applications:\n\n" mutableCopy];
-        NSEnumerator *e = [patchedApps objectEnumerator];
-        DeVercruesseProcess *app;
-        int retval;
-
-        while ( (app = [e nextObject]) != nil) {
-            [message appendFormat: @"    ¥ %@\n", [app name]];
-        }
-
-        [message appendString: @"\nIf F-Script Anywhere quits now, these applications will be forced to quit, and any changes you have made in them will be lost.\n\nPlease quit these applications before quitting F-Script Anywhere, or click Force Quit to continue."];
-
-        retval = NSRunAlertPanel(@"Force applications to quit?", message, @"DonÕt Quit", @"Force Quit", nil);
-        if (retval != NSAlertAlternateReturn) {
-            return NO;
-        }
-
-        [(FSAApp *)NSApp unloadBundles: self];
-    }
-
-    return YES;
-}
-
 @end
 
@@ -359,5 +376,5 @@
 {
     static NSMenu *dockMenu = nil;
-    NSMenuItem *menuItem;
+    id<NSMenuItem> menuItem;
     DeVercruesseProcess *frontApp = [processManager frontProcess];
     NSString *appName = [frontApp name];
@@ -375,14 +392,14 @@
     }
 
-    NSAssert(frontApp != nil && appName != nil, @"CanÕt obtain information on the frontmost application");
+    NSAssert(frontApp != nil && appName != nil, @"Can't obtain information on the frontmost application");
 
     if ([patchedApps containsObject: frontApp]) {
-        status = [NSString stringWithFormat: @"Installed in Ò%@Ó", appName];
+        status = [NSString stringWithFormat: NSLocalizedString(@"Installed in '%@'", "Dock menu disabled item displayed when FSA already installed, app name parameter"), appName];
     } else if (![cocoaApps containsObject: frontApp]) {
-        status = [NSString stringWithFormat: @"CanÕt install because Ò%@Ó is not a Cocoa application", appName];
+        status = [NSString stringWithFormat: NSLocalizedString(@"Can't install because '%@' is not a Cocoa application", "Dock menu disabled item displayed when frontmost app not Cocoa, app name parameter"), appName];
     }
 
     if (status == nil) {
-        menuItem = [dockMenu addItemWithTitle: [NSString stringWithFormat: @"Install in Ò%@Ó", appName]
+        menuItem = [dockMenu addItemWithTitle: [NSString stringWithFormat: NSLocalizedString(@"Install in '%@'", "Dock menu item to install FSA in frontmost app"), appName]
                                        action: @selector(invoke)
                                 keyEquivalent: @""];
@@ -406,8 +423,3 @@
 }
 
-- (NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication *)sender;
-{
-    return ([self windowShouldClose: self] ? NSTerminateNow : NSTerminateCancel);
-}
-
 @end
Index: trunk/Cocoa/F-Script Anywhere/Source/FSABundle.mm
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/FSABundle.mm	(revision 153)
+++ trunk/Cocoa/F-Script Anywhere/Source/FSABundle.mm	(revision 153)
@@ -0,0 +1,77 @@
+//
+//  FSABundle.mm
+//  F-Script Anywhere
+//
+//  Created by Nicholas Riley on Fri Feb 01 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+/*
+
+ F-Script Anywhere is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2 of the License, or
+ (at your option) any later version.
+
+ F-Script Anywhere is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License
+ along with F-Script Anywhere; if not, write to the Free Software
+ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+*/
+
+#include <Carbon/Carbon.h>
+#include "SCPatchClient.h"
+#include "SCPatchPrivate.h"
+#include <stdio.h>
+#import "FSAnywhere.h"
+#import "FSAController.h"
+
+class FSAPatchClient : public SCPatchClient
+{
+public:
+    virtual OSErr Initialize(CFStringRef /* clientBundleID */, 
+                             CFStringRef /* controllerBundleID */, 
+                             pid_t /* pid */);
+    virtual void ReceiveMessage(const AppleEvent * /* theAE */);
+};
+
+OSErr FSAPatchClient::Initialize(CFStringRef clientBundleID,
+                                 CFStringRef controllerBundleID, 
+                                 pid_t pid)
+{
+    FSALog(@"client = %@", (NSString *)clientBundleID);
+    FSALog(@"controller = %@", (NSString *)controllerBundleID);
+    [FSAController installMenu];
+    return noErr;
+}
+
+void FSAPatchClient::ReceiveMessage(const AppleEvent *theAE)
+{
+    OSErr err = noErr;
+    Size actualSize;
+    DescType actualType;
+    OSType eventClass, eventID;
+    
+    // XXX is this implementation even necessary?
+    if ( (err = AEGetAttributePtr(theAE, keyEventIDAttr, typeType, &actualType, &eventID,
+                                  sizeof(OSType), &actualSize)) != noErr)
+        return;
+    
+    if ( (err = AEGetAttributePtr(theAE, keyEventClassAttr, typeType, &actualType,
+                                  &eventClass, sizeof(OSType), &actualSize)) != noErr)
+        return;
+    
+    if (eventClass == kSCMessageClass && eventID == kSCPing) {
+        fprintf(stderr, "client received ping: sending reply...\n");
+        SendMessage(mControllerBundleID, NULL, kSCMessageClass, kSCPing, "");
+        fprintf(stderr, "reply sent\n");
+    }
+}
+
+FSAPatchClient FSAPatchClientInstance;
+SCPatchClient *SCPatchClient::sGlobalPatchClientInstance = &FSAPatchClientInstance;
Index: trunk/Cocoa/F-Script Anywhere/Source/FSAController.h
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/FSAController.h	(revision 19)
+++ trunk/Cocoa/F-Script Anywhere/Source/FSAController.h	(revision 153)
@@ -45,3 +45,5 @@
 - (System *)system;
 
++ (void)installMenu;
+
 @end
Index: trunk/Cocoa/F-Script Anywhere/Source/FSAController.m
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/FSAController.m	(revision 19)
+++ trunk/Cocoa/F-Script Anywhere/Source/FSAController.m	(revision 153)
@@ -52,7 +52,7 @@
     if (!alreadyInstalled && ((mainMenu = [NSApp mainMenu]) != nil)) {
         NSMenu *insertIntoMenu = nil;
-        NSMenuItem *item;
+        id<NSMenuItem> item;
         unsigned insertLoc = NSNotFound;
-        NSBundle *bundle = [NSBundle bundleForClass:self];
+        NSBundle *bundle = [NSBundle bundleForClass: self];
         NSMenu * beforeSubmenu = [NSApp windowsMenu];
         // Succeed or fail, we do not try again.
@@ -106,5 +106,5 @@
             [fsaMenu addItemWithTitle: NSLocalizedStringFromTableInBundle(@"Associate With Interface", @"FSA", bundle, @"Title of Associate with Interface menu item") action: @selector(FSA_associateWithInterface:) keyEquivalent: @""];
             [fsaMenu addItem: [NSMenuItem separatorItem]];
-            item = [fsaMenu addItemWithTitle: NSLocalizedStringFromTableInBundle(@"About F-Script AnywhereÉ", @"FSA", bundle, @"Title of Info Panel menu item") action:@selector(showInfo:) keyEquivalent: @""];
+            item = [fsaMenu addItemWithTitle: NSLocalizedStringFromTableInBundle(@"About F-Script Anywhere...", @"FSA", bundle, @"Title of Info Panel menu item") action:@selector(showInfo:) keyEquivalent: @""];
             [item setTarget: self];
             [[FSAWindowManager sharedManager] setWindowMenu: fsaMenu];
@@ -137,9 +137,4 @@
 }
 
-+ (void)load;
-{
-    [self installMenu];
-}
-
 - (id)init {
     self = [super initWithWindowNibName: @"FSAInterpreterPanel"];
@@ -150,5 +145,5 @@
         static unsigned numInterpWindows = 0;
 
-        NSAssert(window != nil, @"CanÕt get interpreter window!");
+        NSAssert(window != nil, @"Can't get interpreter window!");
         if (interpreterNum == 0) interpreterNum = ++numInterpWindows;
         if ( (label = [self interpreterLabel]) != nil) {
Index: trunk/Cocoa/F-Script Anywhere/Source/FSAViewAssociationController.m
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/FSAViewAssociationController.m	(revision 19)
+++ trunk/Cocoa/F-Script Anywhere/Source/FSAViewAssociationController.m	(revision 153)
@@ -31,9 +31,4 @@
 #import <FScript/FSInterpreter.h>
 #import <FScript/System.h>
-
-// XXX workaround for lack of identifier validation; should go away when F-Script adds (promised) direct support for this
-@interface Compiler
-+ (BOOL)isValidIndentifier:(NSString *)str;
-@end
 
 @implementation FSAViewAssociationController
@@ -77,5 +72,5 @@
     [statusField setStringValue: @""];
     if ([variableName length] != 0) {
-        if (![Compiler isValidIndentifier: variableName]) {
+        if (![FSInterpreter validateSyntaxForIdentifier: variableName]) {
             [statusField setStringValue: @"Invalid name: contains spaces, punctuation or non-ASCII characters"];
         } else if (selectedElement != nil) {
@@ -102,8 +97,8 @@
 }
 
-- (void)_addElement:(id)element withLabel:(NSString *)label toSubmenuForItem:(NSMenuItem *)item;
+- (void)_addElement:(id)element withLabel:(NSString *)label toSubmenuForItem:(id<NSMenuItem>)item;
 {
     NSMenu *submenu = [item submenu];
-    NSMenuItem *subItem;
+    id<NSMenuItem> subItem;
     if (submenu == nil) {
         id superElement = [item representedObject];
@@ -127,5 +122,5 @@
 }
 
-- (void)_addValueForSelector:(SEL)sel withLabel:(NSString *)label toSubmenuForItem:(NSMenuItem *)item;
+- (void)_addValueForSelector:(SEL)sel withLabel:(NSString *)label toSubmenuForItem:(id<NSMenuItem>)item;
 {
     id obj = [item representedObject];
@@ -139,5 +134,5 @@
 - (void)_addElementToMenu:(id)element;
 {
-    NSMenuItem *item;
+    id<NSMenuItem> item;
     if (element == nil) return;
     item = [viewHierarchyMenu addItemWithTitle: [@"  "
@@ -271,5 +266,4 @@
 - (IBAction)defineVariable:(id)sender;
 {
-#warning this should change when F-Script supports a public API for identifier validation
     NS_DURING
         NSString *variableName = [variableNameField stringValue];
Index: trunk/Cocoa/F-Script Anywhere/Source/FSAWindowManager.h
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/FSAWindowManager.h	(revision 19)
+++ trunk/Cocoa/F-Script Anywhere/Source/FSAWindowManager.h	(revision 153)
@@ -12,5 +12,5 @@
     NSMenu *menu;
     NSMutableDictionary *records;
-    NSMenuItem *separator, *label;
+    id<NSMenuItem> separator, label;
 }
 
Index: trunk/Cocoa/F-Script Anywhere/Source/FSAnywhere.h
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/FSAnywhere.h	(revision 19)
+++ trunk/Cocoa/F-Script Anywhere/Source/FSAnywhere.h	(revision 153)
@@ -7,9 +7,20 @@
  *
  */
-#import <Foundation/Foundation.h>
 
-#define FSA_DEBUG 0
-#define FSA_VERSION "1.1.5"
+#define FSA_VERSION "1.2b1"
+#define FSA_FSCRIPT_MIN_VERSION 0x1252001 /* 1.2.5d1 */
+#define FSA_DEBUG
 
-extern void FSALog(NSString *fmt, ...);
-extern NSString * FSA_FScriptURL;
+#ifdef FSA_DEBUG
+    #define FSALog(...) NSLog(@"F-Script Anywhere: %@", [NSString stringWithFormat: __VA_ARGS__]);
+    #define FSAShow(obj) CFShow(obj);
+#else
+    #define FSALog(...) ;
+    #define FSAShow(obj) ;
+#endif
+
+#ifdef OBJC_EXPORT
+    extern NSString * FSA_FScriptURL;
+    /* should match FSA_FSCRIPT_MIN_VERSION above */
+    extern NSString * FSA_FScriptMinimumVersion;
+#endif
Index: trunk/Cocoa/F-Script Anywhere/Source/FSAnywhere.m
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/FSAnywhere.m	(revision 19)
+++ trunk/Cocoa/F-Script Anywhere/Source/FSAnywhere.m	(revision 153)
@@ -7,16 +7,7 @@
 //
 
+#import <Foundation/Foundation.h>
 #import "FSAnywhere.h"
 
-// wish we could #define out completely, but it seems impossible to use varargs #defines on OS X's cpp
-
-void FSALog(NSString *fmt, ...) {
-#if FSA_DEBUG
-    va_list ap;
-    va_start(ap, fmt);
-    NSLogv([NSString stringWithFormat: @"F-Script Anywhere: %@", fmt], ap);
-#endif
-}
-
-// XXX put this in a .strings file instead
 NSString * FSA_FScriptURL = @"http://www.fscript.org/";
+NSString * FSA_FScriptMinimumVersion = @"1.2.5";
Index: trunk/Cocoa/F-Script Anywhere/Source/Info-Application.plist
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/Info-Application.plist	(revision 153)
+++ trunk/Cocoa/F-Script Anywhere/Source/Info-Application.plist	(revision 153)
@@ -0,0 +1,33 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
+<dict>
+	<key>CFBundleDevelopmentRegion</key>
+	<string>English</string>
+	<key>CFBundleExecutable</key>
+	<string>F-Script Anywhere</string>
+	<key>CFBundleGetInfoString</key>
+	<string>F-Script Anywhere 1.2b1,
+© 2002–04 Nicholas Riley</string>
+	<key>CFBundleIconFile</key>
+	<string>Application icon</string>
+	<key>CFBundleIdentifier</key>
+	<string>net.sabi.FScriptAnywhereApp</string>
+	<key>CFBundleInfoDictionaryVersion</key>
+	<string>6.0</string>
+	<key>CFBundleName</key>
+	<string>F-Script Anywhere</string>
+	<key>CFBundlePackageType</key>
+	<string>APPL</string>
+	<key>CFBundleShortVersionString</key>
+	<string>1.2b1</string>
+	<key>CFBundleSignature</key>
+	<string>FSAn</string>
+	<key>CFBundleVersion</key>
+	<string>1.2b1</string>
+	<key>NSMainNibFile</key>
+	<string>MainMenu</string>
+	<key>NSPrincipalClass</key>
+	<string>FSAApp</string>
+</dict>
+</plist>
Index: trunk/Cocoa/F-Script Anywhere/Source/NJRScrollView.m
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/NJRScrollView.m	(revision 19)
+++ trunk/Cocoa/F-Script Anywhere/Source/NJRScrollView.m	(revision 153)
@@ -9,4 +9,7 @@
 #import "NJRScrollView.h"
 
+#ifndef NSAppKitVersionNumber10_2
+#define NSAppKitVersionNumber10_2 663
+#endif
 
 @implementation NJRScrollView
@@ -14,4 +17,7 @@
 - (BOOL)needsDisplay;
 {
+    // Mac OS X 10.3 and later have support for external focus rings
+    if (floor(NSAppKitVersionNumber) > NSAppKitVersionNumber10_2)
+        return [super needsDisplay];
     NSResponder *resp = nil;
     if ([[self window] isKeyWindow]) {
@@ -30,4 +36,7 @@
 - (void)drawRect:(NSRect)rect {
     [super drawRect: rect];
+    // Mac OS X 10.3 and later have support for external focus rings
+    if (floor(NSAppKitVersionNumber) > NSAppKitVersionNumber10_2)
+        return;
     if (shouldDrawFocusRing) {
         NSSetFocusRingStyle(NSFocusRingOnly);
Index: trunk/Cocoa/F-Script Anywhere/Source/NSString-NJRExtensions.m
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/NSString-NJRExtensions.m	(revision 19)
+++ trunk/Cocoa/F-Script Anywhere/Source/NSString-NJRExtensions.m	(revision 153)
@@ -14,4 +14,8 @@
 #import "NSString-NJRExtensions.h"
 
+#ifndef NSAppKitVersionNumber10_2
+#define NSAppKitVersionNumber10_2 663
+#endif
+
 @implementation NSString (NJRExtensions)
 
@@ -20,28 +24,14 @@
     NSAttributedString *s = [NSAttributedString alloc];
     NSMutableParagraphStyle *ps = [[NSParagraphStyle defaultParagraphStyle] mutableCopy];
-    OSStatus err;
-    /*
-    NSString *fs;
-    Str255 font;
-    SInt16 size; // label font is 10, pushbutton font 13, views font is 12!
-    err = GetThemeFont(kThemeViewsFont, smUnicodeScript, font, &size, NULL);
-    fs = CFStringCreateWithPascalString(kCFAllocatorDefault, font, CFStringGetSystemEncoding());
-    NSLog(@"Theme font: %@ %d", fs, size);
-    */
-    err = TruncateThemeText((CFMutableStringRef) text, kThemeViewsFont,
-                            kThemeStateActive, width, truncMiddle, NULL);
-    /* // There's a workaround for a 10.1 bug in Connections' awakeFromNib: the initial
-       // column size is wrong, until you resize the window.  Here's how to demonstrate the bug:
-    {   static float lastWidth = 0; // XXX debug
-        if (lastWidth != width) {
-            lastWidth = width;
-            NSLog(@"Got width %f", width);
-        }
+    if (floor(NSAppKitVersionNumber) > NSAppKitVersionNumber10_2) {
+        [ps setLineBreakMode: NSLineBreakByTruncatingMiddle];
+    } else {
+        // Mac OS X versions earlier than 10.3 don't implement NSLineBreakByTruncatingMiddle; fake it
+        OSStatus err;
+        err = TruncateThemeText((CFMutableStringRef) text, kThemeViewsFont,
+                                kThemeStateActive, width, truncMiddle, NULL);
+        if (err != noErr) FSALog(@"-[NSString asAttributedStringTruncatedToWidth:]: TruncateThemeText failed with error %d", err);
+        [ps setLineBreakMode: NSLineBreakByClipping];
     }
-    */
-    if (err != noErr) FSALog(@"-[NSString asAttributedStringTruncatedToWidth:]: TruncateThemeText failed with error %d", err);
-    // XXX Should be able to skip the above by using NSLineBreakByTruncatingMiddle,
-    // XXX but OS X 10.1 doesn't implement it yet.
-    [ps setLineBreakMode: NSLineBreakByClipping];
     s = [s initWithString: text attributes:
            [NSDictionary dictionaryWithObjectsAndKeys: ps, NSParagraphStyleAttributeName, nil]];
Index: trunk/Cocoa/F-Script Anywhere/Source/Read Me
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/Read Me	(revision 19)
+++ trunk/Cocoa/F-Script Anywhere/Source/Read Me	(revision 153)
@@ -1,4 +1,4 @@
-F-Script Anywhere 1.1.5 [1 October 2002]
-=======================
+F-Script Anywhere 1.2 [5 January 2004]
+=====================
 
 Add a F-Script interpreter to Cocoa applications dynamically.
@@ -24,8 +24,9 @@
 directory, such as /Library/Frameworks or ~/Library/Frameworks.
 
-F-Script Anywhere 1.1.5 was tested with FScript.framework 1.2.2
-(20020604), Mac OS X 10.1.5 (5S66) and 10.2.1 (6D52).  It may or may
-not work with earlier or later versions, I don't know.  If you are
-using an earlier F-Script version, please upgrade.
+F-Script Anywhere 1.2 was tested with FScript.framework 1.2.5
+(20031020) and Mac OS X 10.3.2 (7D24).  If you are using an earlier
+F-Script version, please upgrade.  F-Script Anywhere 1.2 should also
+work with Mac OS X 10.2.x, but will not work with Mac OS X 10.1 or
+earlier: please use F-Script Anywhere 1.1.5 instead.
 
 
@@ -50,9 +51,8 @@
 explaining the problem.
 
-When you're finished, quit the application before quitting F-Script
-Anywhere, otherwise the application will crash.  This is an inherent
-limitation of the Objective-C runtime, and I can't do anything about
-it.  F-Script Anywhere will warn you if you try to quit it when it's
-still installed in active applications.
+To remove F-Script Anywhere from an application, quit the application.
+Because of limitations in Apple's Objective-C runtime, it is
+impossible to remove F-Script Anywhere while the application is
+running.
 
 
@@ -65,27 +65,5 @@
 1. Install FScript.framework (see above).
 
-2. Install libPatch 1.2.1.
-
-   <http://web.sabi.net/nriley/software/libPatch-1.2.1.tgz>
-
-   I'd suggest you do it this way:
-
-   % cd /
-   % sudo gnutar --preserve-permissions -zxf libPatch-1.2.1.tgz
-   Password:
-     (please don't use StuffIt Expander)
-
-   This installs files in /Developer/Examples and
-   /usr/local/{bin,include,lib}.  If you're paranoid, you may want to
-   check the contents of the directory before installing.
-
-   Please note that the layout of the libPatch distribution has changed
-   since libPatch 1.0; the above instructions will not work for 1.0.
-   
-   I did not write libPatch, but am distributing it for your convenience
-   because it may be unavailable from its original source.  libPatch is
-   unsupported; please do not contact libPatchÕs author for support.
-
-3. Check out the source of 'otool' from the Darwin CVS repository.
+2. Check out the source of 'otool' from the Darwin CVS repository.
    This is required because there's a bug in the function that returns
    the 'flavo(u)r' of an application: Cocoa, Carbon, Classic, etc.
@@ -104,10 +82,11 @@
    jam/pbxbuild).  I _think_ this is all you need.
 
-4. Open 'F-Script Anywhere.pbproj' in Project Builder and build the
-   Application target.  It depends on the Library target, so you don't
-   need to build it separately.  You shouldnÕt see any errors or
-   warnings, and the F-Script Anywhere application (as well as the
-   library, which you can ignore because it is also copied into the
-   application bundle) will appear in the build product directory.
+3. Open 'F-Script Anywhere.pbproj' in Xcode and build the Application
+   target.  This target depends on the Bundle and Bundle Loader
+   targets, so you don't need to build them separately.  You
+   shouldnÕt see any errors or warnings, and the F-Script Anywhere
+   application (as well as two bundles, which you can ignore because
+   they are copied into the application bundle) will appear in the
+   build product directory.
 
 If you have any problems building F-Script Anywhere, please let me
@@ -173,24 +152,6 @@
    element, view it in an object browser or assign it to a variable.
 
-
-Q. F-Script Anywhere fails miserably on Jaguar.
-
-A. It shouldnÕt.  Apple re-added support for libPatch to Jaguar late
-   in the development process, with the result that F-Script Anywhere
-   works.  libPatch nevertheless needs to be replaced with a more
-   robust mechanism, and I am currently working on using the Application
-   Enhancer SDK <http://www.unsanity.com/haxies/ape/sdk/> for a future
-   version of F-Script Anywhere.
-
-
-Q. F-Script Anywhere fails to recognize Spring as a Cocoa application.
-
-A. Yes, I'm aware of the irony: I contributed code to Spring.  Spring
-   uses a unique application launching mechanism which makes it
-   difficult to determine what type of application it is.  The only
-   current workaround is to upgrade to Jaguar, where Spring will be
-   correctly identified.  This problem will be remedied with the move
-   to Application Enhancer, described above, in a future version of
-   F-Script Anywhere.
+   The F-Script object browser now provides a similar feature: click the
+   "Select view" button.
 
 
@@ -218,6 +179,22 @@
 ---------------
 
-1.1.6 -                 - better manage window on startup (only display
-                          when launch complete)
+1.2   - 5 January 2004  - fixed window behavior on startup, delaying
+      	  	  	  display until launch is complete
+			- replaced libPatch with mach_inject and
+                          SCPatch: provides improved compatibility
+                          with Mac OS X 10.3 (doesn't crash randomly
+			  any more!)
+                        - no longer requires F-Script Anywhere
+			  application to be running while installed
+			  in applications
+			- F-Script Anywhere can now be installed in
+			  itself
+			- check for F-Script version on startup
+			- use new, documented F-Script API for
+			  identifier validation in associate window
+			- prepared for localization
+			- enable "Install" button when appropriate at
+			  application startup
+			- fixed focus ring "flicker" on Mac OS X 10.3
 1.1.5 - 1 October 2002  - better identify Cocoa vs. Carbon applications
                           on Jaguar; added hierarchical window list to
@@ -266,4 +243,6 @@
 
 Philippe Mougin, for F-Script
+Jonathan 'Wolf' Rentsch, for mach_inject
+Jon Gotow, for SCPatch and lots of advice
 Mike Ferris, for TextExtras
 Apple, for Darwin
Index: trunk/Cocoa/F-Script Anywhere/Source/SCPatch/Common/SCPatchCommon.h
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/SCPatch/Common/SCPatchCommon.h	(revision 153)
+++ trunk/Cocoa/F-Script Anywhere/Source/SCPatch/Common/SCPatchCommon.h	(revision 153)
@@ -0,0 +1,18 @@
+#pragma once
+
+typedef struct SCPatchParams
+{
+	short				version;
+	pid_t				parent;
+	HFSUniStr255		parentBundleID;
+	HFSUniStr255		patchBundleID;
+	FSRef				patchRef;
+} SCPatchParams;
+
+typedef	mach_error_t	(*SCPatchEntry)( SCPatchParams *paramBlock );
+
+#define	err_couldnt_load_main_bundle			(err_local|1)
+#define	err_couldnt_find_injection_bundle		(err_local|2)
+#define	err_couldnt_load_injection_bundle		(err_local|3)
+#define	err_couldnt_find_injectedThread_symbol	(err_local|4)
+#define	err_couldnt_find_patch_bundle			(err_local|5)
Index: trunk/Cocoa/F-Script Anywhere/Source/SCPatch/Common/SCPatchMessages.h
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/SCPatch/Common/SCPatchMessages.h	(revision 153)
+++ trunk/Cocoa/F-Script Anywhere/Source/SCPatch/Common/SCPatchMessages.h	(revision 153)
@@ -0,0 +1,27 @@
+#pragma once
+
+// Messages sent by SCPatch components must all be of type kSCMessageClass.
+// All lowercase message ID's are reserved for internal library use.  Define
+// any messages of your own using upper or mixed case AE ID's.
+#define	kSCMessageClass		'SCmg'
+
+
+// Ping:
+//	controller -> client to test for existence of patch
+#define		kSCPing			'ping'
+//			no params
+
+
+// LoadResult:
+//	loader -> controller to notify of status of patch loading
+#define 	kSCLoadResult	'load'
+#define			keyBundleID	'bndl'	// typeChar - bundleID of patch
+#define			keyError	'err '	// typeInteger - error code (mach_error_t)
+
+
+// PatchSuccess:
+//	client -> controller to notify it of successful patch installation
+//	and initialization.
+#define		kSCPatchSuccess	'p_ok'
+// 				keyBundleID	'bndl'	// typeChar
+#define			keyPSN		'proc'	// typeProcessSerialNumber
